--

with Dout.Data_Object;

with Ada.Text_IO;
with Ada.Numerics.Discrete_Random;

with Bitmap_Format;
with Bitmap_Routines;
with Bitmap_Handling_800;

procedure Put_Random_Colour_Bitmap_800 is
   use Ada;
   use Ada.Numerics;
   use Bitmap_Format;
   use Bitmap_Routines;
   use Bitmap_Handling_800;
   use Dout.Data_Object;

   Rec    : Rectangele_Type := (800, 800);
   Length : Length_Type;

   File_Name    : constant String := "pixel-800.bmp";
   Outfile_Name : constant String := "pixel-800_saved.bmp";

   Read_Nb_Bytes : Length_Type;

   Bf_Type : Unsigned_16_Bit_Integer;
   Bf_Size : Unsigned_32_Bit_Integer;

   Rec_Out : Rectangele_Type := (1, 1);

   Colour_Pixel_Row_Array : Colour_Pixel_Row_Array_Type;

   package Random_Colours is new Discrete_Random (Colour_Value_Type);

   Gr : Random_Colours.Generator;
   Gg : Random_Colours.Generator;
   Gb : Random_Colours.Generator;

begin
   Text_IO.New_Line;
   Text_IO.Put_Line ("## Put_Random_Colour_Bitmap_800 ...");

   -- -- --

   Length := Get_Nb_Of_All_Bytes (Rec);

   Text_IO.Put_Line ("#> Bytes: " & Length'Img);

   Read_Bitmap (Ba => Bitmap_Byte_Array, File_Name => File_Name, Nb_Bytes => Read_Nb_Bytes);

   Text_IO.Put_Line ("#> Read:  " & Read_Nb_Bytes'Img);
   Text_IO.New_Line;

   Bf_Type := Get_Bf_Type_Data (Bitmap_Byte_Array'Address);

   Text_IO.Put_Line ("#> Read Bf_Type: " & Bf_Type'Img);

   Bf_Size := Get_Bf_Size_Data (Bitmap_Byte_Array'Address);

   Text_IO.Put_Line ("#> Read Bf_Size: " & Bf_Size'Img);

   Rec_Out := Get_Width_Height_Data (Bitmap_Byte_Array'Address);

   Text_IO.Put_Line ("#> Read Width, Height: " & Rec_Out.Width'Img & " | " & Rec_Out.Height'Img);
   Text_IO.New_Line;

   Text_IO.Put_Line ("#> All bytes:         " & Nb_Of_All_Bytes'Img);
   Text_IO.Put_Line ("#> All colour bytes:  " & Nb_Of_All_Colour_Bytes'Img);
   Text_IO.Put_Line ("#> Colour line bytes: " & Nb_Of_Colour_Line_Bytes'Img);
   Text_IO.New_Line;

   -- -- --

   Random_Colours.Reset (Gr);
   Random_Colours.Reset (Gg);
   Random_Colours.Reset (Gb);

   for Outer_Index in Height_Index_Type loop
      for Inner_Index in Width_Index_Type loop

         Colour_Pixel_Row_Array (Inner_Index).R := Random_Colours.Random (Gr);
         Colour_Pixel_Row_Array (Inner_Index).G := Random_Colours.Random (Gg);
         Colour_Pixel_Row_Array (Inner_Index).B := Random_Colours.Random (Gb);

--           Colour_Pixel_Row_Array (Inner_Index).R := Random_Colours.Random (Gr);
--           Colour_Pixel_Row_Array (Inner_Index).G := Random_Colours.Random (Gr);
--           Colour_Pixel_Row_Array (Inner_Index).B := Random_Colours.Random (Gr);

      end loop; -- Inner_Index

      Set_Pixel_Row_Array (Bitmap_Byte_Array'Address, Outer_Index, Colour_Pixel_Row_Array);

   end loop; -- Outer_Index
   -- -- -

   Text_IO.New_Line;
   Text_IO.Put_Line ("#> Saving Bitmap ... ");

   Write_Bitmap (Bitmap_Byte_Array, Outfile_Name);

   -- -- --

   Text_IO.New_Line;
   Text_IO.Put_Line ("## Test_Bitmap_Handling_800.");
   Text_IO.Put_Line ("## Wait for CR ...");
   Text_IO.Skip_Line;

end Put_Random_Colour_Bitmap_800;
