--

with Callables;
with Futures;

generic
   type Parameter_Type is private;
   type Result_Type is private;

   with package My_Futures is new Futures (Data_Type => Result_Type);

   with package My_Callables is new Callables
     (Parameter_Type => Parameter_Type,
      Result_Type    => Result_Type);

package Executors is

   type Executor_Type is limited interface;
   type Any_Executor_Acces_Type is access all Executor_Type'Class;

   procedure Submit
     (Exec      : in out Executor_Type;
      Callable  : in     My_Callables.Any_Callable_Access_Type;
      Params    : in     Parameter_Type;
      My_Future : in     My_Futures.Any_Future_Access_Type) is abstract;

end Executors;
