--

generic
   type Data_Type is private;

package Futures is

   type Future_Type is synchronized interface;
   type Any_Future_Access_Type is access all Future_Type'Class;

   procedure Get (F : in out Future_Type; D : out Data_Type) is abstract;
   procedure Set (F : in out Future_Type; D : in Data_Type) is abstract;

   -- -- --
   -- -- --

   type Reusable_Future_Type is synchronized interface and Future_Type;
   type Any_Reusable_Future_Access_Type is access all Reusable_Future_Type'Class;

   overriding procedure Get (F : in out Reusable_Future_Type; D : out Data_Type)
   is abstract;

   overriding procedure Set (F : in out Reusable_Future_Type; D : in Data_Type)
      is abstract;

   -- -- --

   procedure Allocate (F : in out Reusable_Future_Type) is abstract;
   procedure Cancel (F : in out Reusable_Future_Type) is abstract;

end Futures;
