--

with Ada.Real_Time;
with Ada.Task_Identification;
with Ada.Task_Attributes;

package Periodic_Scheduler is
   use Ada;

   type Task_Information_Type is record
      Period             : Real_Time.Time_Span := Real_Time.Time_Span_Zero;
      Next_Schedule_Time : Real_Time.Time      := Real_Time.Time_Of (SC => 100_000, TS => Real_Time.Time_Span_Zero);
   end record;

private

   Default_Task_Informaion : Task_Information_Type;

   package Periodic_Task_Attributes is new Task_Attributes
     (Attribute     => Task_Information_Type,
      Initial_Value => Default_Task_Informaion);

end Periodic_Scheduler;
